<?php
define('DBHOST', 'localhost');
define('DBUSER', 'database user');
define('DBPASS', 'database password');
define('DBNAME', 'database name');
define('TBLNAME', 'notes');

$mysqli = new mysqli(DBHOST, DBUSER, DBPASS, DBNAME);
if (mysqli_connect_errno()) {
	// TODO handle connection error
	printf('Connect failed: %s\n', mysqli_connect_error());
	exit();
}

if ($_POST['action'] == 'load') {
	// Load notes for the given photo
	$photoIds = explode('~', $_POST['photo_ids']);
	reset($photoIds);
	foreach($photoIds as $key => $photoId)
		$photoIds[$key] = $mysqli->real_escape_string($photoId);
	$sqlIn = "('" . implode("','", $photoIds) . "')";
	$sql = 'SELECT `photo_id`, `note_id`, `left`, `top`, `width`, `height`, `text` FROM ' . TBLNAME . " WHERE photo_id IN $sqlIn";
	$results = $mysqli->query($sql);
	while ($note = $results->fetch_object()) {
		echo "var note = new PhotoNote('$note->text', $note->note_id, new PhotoNoteRect($note->left, $note->top, $note->width, $note->height));\n";
		echo "note.onsave = saveNote;\n";
		echo "note.ondelete = deleteNote;\n";
		echo "containers['$note->photo_id'].AddNote(note);\n";
	}
}
else if ($_POST['action'] == 'save') {
	// Save action
	$photoId = $mysqli->real_escape_string($_POST['photo_id']);
	$text    = $mysqli->real_escape_string($_POST['text']);
	$left    = intval($_POST['left']);
	$top     = intval($_POST['top']);
	$width   = intval($_POST['width']);
	$height  = intval($_POST['height']);

	if ($_POST['note_id'] == -1) {
		// Insert new note
		$sql = 'INSERT INTO ' . TBLNAME . " (`photo_id`, `note_id`, `left`, `top`, `width`, `height`, `text`)
			VALUES ('$photoId', NULL, $left, $top, $width, $height, '$text')";
		if ($mysqli->query($sql)) {
			$noteId = $mysqli->insert_id;
		} else {
			// TODO handle insert error ($mysqli->error)
			$noteId = "0"; // error
		}
	} else {
		// Update existing note
		$noteId = intval($_POST['note_id']);
		$sql = 'UPDATE ' . TBLNAME . " SET `left` = $left, `top` = $top, `width` = $width, `height` = $height, `text` = '$text'
			WHERE photo_id = '$photoId' AND note_id = $noteId";
		if (!$mysqli->query($sql)) {
			// TODO handle delete error ($mysqli->error)
			$noteId = "0"; // error
		}
	}
	// Return note ID to calling page
	echo $noteId;
}
else if ($_POST['action'] == 'delete') {
	// Delete action
	$photoId = $mysqli->real_escape_string($_POST['photo_id']);
	$noteId  = $mysqli->real_escape_string($_POST['note_id']);
	$sql = 'DELETE FROM ' . TBLNAME . " WHERE photo_id = '$photoId' AND note_id = $noteId";
	if (!$mysqli->query($sql)) {
		// TODO handle delete error ($mysqli->error)
		echo "0"; // error
	}
	echo "1"; // success
}
?>
